const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const wishlists = sequelize.define(
    'wishlists',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

is_default: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  wishlists.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity























    db.wishlists.hasMany(db.wishlist_items, {
      as: 'wishlist_items_wishlist',
      foreignKey: {
          name: 'wishlistId',
      },
      constraints: false,
    });






//end loop



    db.wishlists.belongsTo(db.users, {
      as: 'customer',
      foreignKey: {
        name: 'customerId',
      },
      constraints: false,
    });




    db.wishlists.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.wishlists.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return wishlists;
};


